Attribute VB_Name = "Module1"
    Const dim4 = 10
    ' Public mat1(dim4, dim4), fx(dim4), sol(dim4) As Double
    ' Public m(dim4), x(dim4), y(dim4), vx(dim4), vy(dim4), ax(dim4), ay(dim4) As Double
    ' Public x0(dim4), y0(dim4), x1(dim4), y1(dim4), x2(dim4), y2(dim4), aax(dim4), aay(dim4) As Double

Public x0(10), x1(10), y0(10), y1(10) As Double
Public l1, steps, isteps, iclsel, dxy, t, g, newtab

Public xmax, ymax, xchrmax, ychrmax, fract, scren%
Public CGx, CGy                      ' Center of Gravity
Public x0h(2), x1h(2), y0h(2), y1h(2), m(2) As Double     ' historic values

Sub Main()
    
    If dxy = 0 Then Exit Sub          ' Called initial via TAB keys etc
    
    Black = QBColor(0)
    blue = QBColor(1)
    LightRed = QBColor(4)
    gray1 = QBColor(7)
    Green = QBColor(10)
    Red = QBColor(12)
    Yellow = QBColor(14)
    
    INITIALISE1
    
    xmax2 = Form2.ScaleWidth
    ymax2 = Form2.ScaleHeight
    ycor = ymax2 / 2 - 200
    xcor = xmax2 / 2 - 300

    If newtab = 0 Then Form2.Cls
    
    ax01 = -2 * x0(1) + x0(0) + x0(2)
    ay01 = -2 * y0(1) + y0(0) + y0(2)
    a0 = Sqr(ax01 * ax01 + ay01 * ay01)
    dx1 = x0(1) - x1(1): dy1 = y0(1) - y1(1)
    r1 = Sqr(dx1 * dx1 + dy1 * dy1)           ' r1 = distance between observation 2 of m0 and m1
    m(1) = a0 * r1 * r1 / g                   ' a0 = g * m1 / r^2
    Debug.Print "m1 left "; m(1)
    Form1.Tmass(1).Text = Int(m(1))
    
    ax11 = -2 * x1(1) + x1(0) + x1(2)
    ay11 = -2 * y1(1) + y1(0) + y1(2)
    a1 = Sqr(ax11 * ax11 + ay11 * ay11)
    m(0) = a1 * r1 * r1 / g                   ' a1 = g * m0 / r^2
    Form1.Tm2m1.Text = m(1) / m(0)
    
    Debug.Print "m0 right "; m(0); m(1) / m(0)
    Form1.Tmass(0).Text = Int(m(0))
    
    dx0 = x0(0) - x1(0): dy0 = y0(0) - y1(0)
    r0 = Sqr(dx0 * dx0 + dy0 * dy0): rrr0 = r0 * r0 * r0
    ax00 = g * m(1) * -dx0 / rrr0: vx00 = x0(1) - x0(0) - ax00 / 2
    ay00 = g * m(1) * -dy0 / rrr0: vy00 = y0(1) - y0(0) - ay00 / 2
    ax10 = g * m(0) * dx0 / rrr0: vx10 = x1(1) - x1(0) - ax10 / 2
    ay10 = g * m(0) * dy0 / rrr0: vy10 = y1(1) - y1(0) - ay10 / 2

    ''LOCATE 4, 1:
    Debug.Print "G = "; g;
    ''LOCATE 4, 64:
    Debug.Print "hor"; Tab(74); "ver"
    ''LOCATE 5, 60:
    If iclsel = 3 Then QBColor 12 Else QBColor 7
    Debug.Print "3";: Debug.Print x0(2); 400 - y0(2)
    ''LOCATE 6, 60:
    If iclsel = 2 Then QBColor 12 Else QBColor 7
    Debug.Print "2";: Debug.Print x0(1); 400 - y0(1)
    ''LOCATE 7, 60:
    If iclsel = 1 Then QBColor 12 Else QBColor 7
    Debug.Print "1";: Debug.Print x0(0); 400 - y0(0)
    x0(4) = x0(0): y0(4) = y0(0): x1(4) = x1(0): y1(4) = y1(0)
    vx02 = vx00: vy02 = vy00: vx12 = vx10: vy12 = vy10

    ' Update historic values
    For i = 0 To 2
        kleur = Black
        Form2.PSet (x0(i) + xcor, y0(i) + ycor), kleur
        Form2.PSet (x1(i) + xcor, y1(i) + ycor), kleur
        ' save old values for display purposes.
        x0h(i) = x0(i): y0h(i) = y0(i): x1h(i) = x1(i): y1h(i) = y1(i)
    Next i
    icl = 0
    
    Form2.PSet (CGx + xcor, CGy + ycor), blue
   
For i = 0 To steps
  dx2 = x1(4) - x1(1): dy2 = y1(4) - y1(1)
  r2 = Sqr(dx2 * dx2 + dy2 * dy2)               ' distance from origin of left
  If (i > 10 * isteps And r2 < 10) Or r2 > 400 Then GoTo mass2  ' terminate
  x0(3) = x0(4): x1(3) = x1(4): y0(3) = y0(4): y1(3) = y1(4)
  vx01 = vx02: vy01 = vy02: vx11 = vx12: vy11 = vy12
  dx2 = x0(3) - x1(3): dy2 = y0(3) - y1(3)
  r2 = Sqr(dx2 * dx2 + dy2 * dy2): rrr2 = r2 * r2 * r2
  ax02 = g * m(1) * -dx2 / rrr2: vx02 = vx01 + ax02 * t: x0(4) = x0(3) + vx02 * t
  ay02 = g * m(1) * -dy2 / rrr2: vy02 = vy01 + ay02 * t: y0(4) = y0(3) + vy02 * t
  ax12 = g * m(0) * dx2 / rrr2: vx12 = vx11 + ax12 * t: x1(4) = x1(3) + vx12 * t
  ay12 = g * m(0) * dy2 / rrr2: vy12 = vy11 + ay12 * t: y1(4) = y1(3) + vy12 * t
  If i Mod isteps = isteps - 1 Then
    icl = icl + 1
    kleur = Black
    If icl = 4 And newtab = 1 Then newtab = 0: GoTo mass2   ' terminate
    If icl < 3 Then
      x0(icl) = x0(4): y0(icl) = y0(4): x1(icl) = x1(4): y1(icl) = y1(4)
    End If
    Form2.PSet (x0(4) + xcor, y0(4) + ycor), kleur
    Form2.PSet (x1(4) + xcor, y1(4) + ycor), kleur
  End If
Next i

mass2:

For i = 0 To 2
  If i = iclsel - 1 Then
      Form1.Tx(i).ForeColor = Red: Form1.Ty(i).ForeColor = Red
      Form1.Lsel(i).ForeColor = Red
  Else
      Form1.Tx(i).ForeColor = Black: Form1.Ty(i).ForeColor = Black
      Form1.Lsel(i).ForeColor = Black
  End If
  Form1.Tx(i).Text = x0h(i): Form1.Ty(i).Text = 400 - y0h(i)
  If i = iclsel - 1 Then kleur = Red Else kleur = Green
  ' Form2.PSet (x0(i), y0(i)), kleur:
  Form2.PSet (x0h(i) + xcor, y0h(i) + ycor), kleur
  ' Form2.PSet (x1(i), y1(i)), kleur:
  Form2.PSet (x1h(i) + xcor, y1h(i) + ycor), kleur
Next i

End Sub

Public Sub INITIALISE1()
'                                                        INITIALISE1
dx0 = x0(0) - x0(1): dy0 = y0(0) - y0(1)
r1 = Sqr(dx0 * dx0 + dy0 * dy0)            'r1 = length between pos 1,2 of m0
x1(1) = x1(0) - l1 / r1 * (x0(1) - x0(0))  'l1 = length between pos 1,2 of m1
y1(1) = y1(0) - l1 / r1 * (y0(1) - y0(0))
dx0 = x0(1) - x0(2): dy0 = y0(1) - y0(2)
r2 = Sqr(dx0 * dx0 + dy0 * dy0)            'r2 = length between pos 2,3 of m0
l2 = l1 * r2 / r1                          'l2 = length between pos 2,3 of m1
x1(2) = x1(1) - l1 / r1 * (x0(2) - x0(1))
y1(2) = y1(1) - l1 / r1 * (y0(2) - y0(1))

r = x0(0) - x1(0)                          ' Distance between object 1 and 2
r2 = r * l1 / (l1 + r1)
CGx = x1(0) + r2:
r = y0(0) - y1(0)                          ' Distance between object 1 and 2
r2 = r * l1 / (l1 + r1)
CGy = y1(0) + r2

' Debug.Print "x1(0)"; x1(0); " CGx "; CGx; " x0(0) "; x0(0)

End Sub


